from django.shortcuts import render, get_object_or_404, redirect
from seller.models import ProductData as sellerproduct
from kisan.models import ProductData as kisanproduct
from accounts.models import SellerData
from cart.models import PCart, Quantity, ContactList, ContactCart, CPCart
from django.db.models import Sum
from reportlab.pdfgen import canvas
from reportlab.lib.pagesizes import A4
from MandiGram.settings import MEDIA_ROOT
from django.contrib.auth.decorators import login_required
from django.contrib import messages


# Create your views here.
@login_required
def showcart(request):
    num_res = PCart.objects.filter(user=request.user).count()
    num_res1 = CPCart.objects.filter(user=request.user).count()
    if num_res == 0:
        p = PCart(user=request.user)
        p.save()
    elif num_res1 == 0:
        p = CPCart(user=request.user)
        p.save()

    # p1 = PCart.objects.get(user__iexact=request.user.username)
    # p2 = CPCart.objects.get(user__iexact=request.user.username)
    p1 = PCart.objects.get(user=request.user)
    p2 = CPCart.objects.get(user=request.user)
    total = 0
    x = list(p1.p_name.values())+list(p2.p_name.values())
    y = list(p1.quant.values())+list(p2.quant.values())
    try:
        for i, j in zip(x, y):
            total += int(i['p_price']) * int(j['min_q'])
    except:
        total = "calculation Error"
    return render(request, 'cart/showcart.html', {'prod': p1, 'cprod':p2, 'total': total, 'cont_list':'p2'})


def removecart(request, object_prod_id, object_quant_id, object_type):
    num_res = PCart.objects.filter(user=request.user).count()
    num_res1 = CPCart.objects.filter(user=request.user).count()
    if num_res == 0:
        p = PCart(user=request.user)
        p.save()
    elif num_res1 == 0:
        p = CPCart(user=request.user)
        p.save()
    else: pass
    if num_res != 0 and object_type == 'SP':
        # p1 = PCart.objects.get(user__iexact=request.user.username
        p1 = PCart.objects.get(user=request.user)
        q1 = get_object_or_404(sellerproduct, id=object_prod_id)
        q2 = get_object_or_404(Quantity, id=object_quant_id)
        p1.p_name.remove(q1)
        p1.quant.remove(q2)
        p1.save()
    if num_res1 != 0 and object_type == 'KP':
        p2 = CPCart.objects.get(user=request.user)
        c1 = get_object_or_404(kisanproduct, id=object_prod_id)
        c2 = get_object_or_404(Quantity, id=object_quant_id)
        p2.p_name.remove(c1)
        p2.quant.remove(c2)
        p2.save()
    return redirect('/cart')


def check(request):
    saving = MEDIA_ROOT + r'\uploads\Invoice.pdf'
    c = canvas.Canvas(filename=saving, pagesize=A4, bottomup=False)
    c.drawString(10, 10, 'ajsj')
    return redirect('/')


@login_required
def contact_slected(request):
    if request.method == 'POST':
        id_del = request.POST.get('condel')
        print(id_del)
        p1 = ContactCart.objects.get(user__iexact=request.user.username)
        q1 = get_object_or_404(ContactList, id=id_del)
        name = q1.s_name
        p1.contact_list.remove(q1)
        p1.save()
        messages.info(request, f'{name} Contact removed from list')
        # return redirect('/')
    num_res = ContactCart.objects.filter(user=request.user.username).count()
    if num_res == 0:
        p = ContactCart(user=request.user.username)
        p.save()
    cont_list = ContactCart.objects.get(user__iexact=request.user.username)
    print(cont_list.contact_list.values())
    total = list(cont_list.contact_list.values()).count
    return render(request, 'cart/contact_list.html', {'total': total, 'cont_list':cont_list})

